# immich-python-sdk
Immich API

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.92.1
- Package version: 1.93.0
- Generator version: 7.14.0-SNAPSHOT
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.9+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/Marian-Braendle/immich-python-sdk.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/Marian-Braendle/immich-python-sdk.git`)

Then import the package:
```python
import immich_python_sdk
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import immich_python_sdk
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import immich_python_sdk
from immich_python_sdk.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://github.com/api
# See configuration.py for a list of all supported configuration parameters.
configuration = immich_python_sdk.Configuration(
    host = "https://github.com/api"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: cookie
configuration.api_key['cookie'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['cookie'] = 'Bearer'

# Configure API key authorization: api_key
configuration.api_key['api_key'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['api_key'] = 'Bearer'

# Configure Bearer authorization (JWT): bearer
configuration = immich_python_sdk.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with immich_python_sdk.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = immich_python_sdk.APIKeyApi(api_client)
    api_key_create_dto = immich_python_sdk.APIKeyCreateDto() # APIKeyCreateDto | 

    try:
        api_response = api_instance.create_api_key(api_key_create_dto)
        print("The response of APIKeyApi->create_api_key:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling APIKeyApi->create_api_key: %s\n" % e)

```

## Documentation for API Endpoints

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*APIKeyApi* | [**create_api_key**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/APIKeyApi.md#create_api_key) | **POST** /api-key | 
*APIKeyApi* | [**delete_api_key**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/APIKeyApi.md#delete_api_key) | **DELETE** /api-key/{id} | 
*APIKeyApi* | [**get_api_key**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/APIKeyApi.md#get_api_key) | **GET** /api-key/{id} | 
*APIKeyApi* | [**get_api_keys**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/APIKeyApi.md#get_api_keys) | **GET** /api-key | 
*APIKeyApi* | [**update_api_key**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/APIKeyApi.md#update_api_key) | **PUT** /api-key/{id} | 
*ActivityApi* | [**create_activity**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ActivityApi.md#create_activity) | **POST** /activity | 
*ActivityApi* | [**delete_activity**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ActivityApi.md#delete_activity) | **DELETE** /activity/{id} | 
*ActivityApi* | [**get_activities**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ActivityApi.md#get_activities) | **GET** /activity | 
*ActivityApi* | [**get_activity_statistics**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ActivityApi.md#get_activity_statistics) | **GET** /activity/statistics | 
*AlbumApi* | [**add_assets_to_album**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AlbumApi.md#add_assets_to_album) | **PUT** /album/{id}/assets | 
*AlbumApi* | [**add_users_to_album**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AlbumApi.md#add_users_to_album) | **PUT** /album/{id}/users | 
*AlbumApi* | [**create_album**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AlbumApi.md#create_album) | **POST** /album | 
*AlbumApi* | [**delete_album**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AlbumApi.md#delete_album) | **DELETE** /album/{id} | 
*AlbumApi* | [**get_album_count**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AlbumApi.md#get_album_count) | **GET** /album/count | 
*AlbumApi* | [**get_album_info**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AlbumApi.md#get_album_info) | **GET** /album/{id} | 
*AlbumApi* | [**get_all_albums**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AlbumApi.md#get_all_albums) | **GET** /album | 
*AlbumApi* | [**remove_asset_from_album**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AlbumApi.md#remove_asset_from_album) | **DELETE** /album/{id}/assets | 
*AlbumApi* | [**remove_user_from_album**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AlbumApi.md#remove_user_from_album) | **DELETE** /album/{id}/user/{userId} | 
*AlbumApi* | [**update_album_info**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AlbumApi.md#update_album_info) | **PATCH** /album/{id} | 
*AssetApi* | [**check_bulk_upload**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#check_bulk_upload) | **POST** /asset/bulk-upload-check | 
*AssetApi* | [**check_existing_assets**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#check_existing_assets) | **POST** /asset/exist | 
*AssetApi* | [**delete_assets**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#delete_assets) | **DELETE** /asset | 
*AssetApi* | [**download_archive**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#download_archive) | **POST** /asset/download/archive | 
*AssetApi* | [**download_file**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#download_file) | **POST** /asset/download/{id} | 
*AssetApi* | [**empty_trash**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#empty_trash) | **POST** /asset/trash/empty | 
*AssetApi* | [**get_all_assets**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_all_assets) | **GET** /asset | 
*AssetApi* | [**get_all_user_assets_by_device_id**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_all_user_assets_by_device_id) | **GET** /asset/device/{deviceId} | 
*AssetApi* | [**get_asset_by_id**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_asset_by_id) | **GET** /asset/assetById/{id} | 
*AssetApi* | [**get_asset_search_terms**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_asset_search_terms) | **GET** /asset/search-terms | 
*AssetApi* | [**get_asset_statistics**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_asset_statistics) | **GET** /asset/statistics | 
*AssetApi* | [**get_asset_thumbnail**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_asset_thumbnail) | **GET** /asset/thumbnail/{id} | 
*AssetApi* | [**get_curated_locations**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_curated_locations) | **GET** /asset/curated-locations | 
*AssetApi* | [**get_curated_objects**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_curated_objects) | **GET** /asset/curated-objects | 
*AssetApi* | [**get_download_info**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_download_info) | **POST** /asset/download/info | 
*AssetApi* | [**get_map_markers**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_map_markers) | **GET** /asset/map-marker | 
*AssetApi* | [**get_memory_lane**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_memory_lane) | **GET** /asset/memory-lane | 
*AssetApi* | [**get_random**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_random) | **GET** /asset/random | 
*AssetApi* | [**get_time_bucket**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_time_bucket) | **GET** /asset/time-bucket | 
*AssetApi* | [**get_time_buckets**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_time_buckets) | **GET** /asset/time-buckets | 
*AssetApi* | [**get_user_assets_by_device_id**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#get_user_assets_by_device_id) | **GET** /asset/{deviceId} | Use /asset/device/:deviceId instead - Remove in 1.92 release
*AssetApi* | [**restore_assets**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#restore_assets) | **POST** /asset/restore | 
*AssetApi* | [**restore_trash**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#restore_trash) | **POST** /asset/trash/restore | 
*AssetApi* | [**run_asset_jobs**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#run_asset_jobs) | **POST** /asset/jobs | 
*AssetApi* | [**search_assets**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#search_assets) | **GET** /assets | 
*AssetApi* | [**serve_file**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#serve_file) | **GET** /asset/file/{id} | 
*AssetApi* | [**update_asset**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#update_asset) | **PUT** /asset/{id} | 
*AssetApi* | [**update_assets**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#update_assets) | **PUT** /asset | 
*AssetApi* | [**update_stack_parent**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#update_stack_parent) | **PUT** /asset/stack/parent | 
*AssetApi* | [**upload_file**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetApi.md#upload_file) | **POST** /asset/upload | 
*AuditApi* | [**fix_audit_files**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuditApi.md#fix_audit_files) | **POST** /audit/file-report/fix | 
*AuditApi* | [**get_audit_deletes**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuditApi.md#get_audit_deletes) | **GET** /audit/deletes | 
*AuditApi* | [**get_audit_files**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuditApi.md#get_audit_files) | **GET** /audit/file-report | 
*AuditApi* | [**get_file_checksums**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuditApi.md#get_file_checksums) | **POST** /audit/file-report/checksum | 
*AuthenticationApi* | [**change_password**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuthenticationApi.md#change_password) | **POST** /auth/change-password | 
*AuthenticationApi* | [**get_auth_devices**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuthenticationApi.md#get_auth_devices) | **GET** /auth/devices | 
*AuthenticationApi* | [**login**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuthenticationApi.md#login) | **POST** /auth/login | 
*AuthenticationApi* | [**logout**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuthenticationApi.md#logout) | **POST** /auth/logout | 
*AuthenticationApi* | [**logout_auth_device**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuthenticationApi.md#logout_auth_device) | **DELETE** /auth/devices/{id} | 
*AuthenticationApi* | [**logout_auth_devices**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuthenticationApi.md#logout_auth_devices) | **DELETE** /auth/devices | 
*AuthenticationApi* | [**sign_up_admin**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuthenticationApi.md#sign_up_admin) | **POST** /auth/admin-sign-up | 
*AuthenticationApi* | [**validate_access_token**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuthenticationApi.md#validate_access_token) | **POST** /auth/validateToken | 
*FaceApi* | [**get_faces**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/FaceApi.md#get_faces) | **GET** /face | 
*FaceApi* | [**reassign_faces_by_id**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/FaceApi.md#reassign_faces_by_id) | **PUT** /face/{id} | 
*JobApi* | [**get_all_jobs_status**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/JobApi.md#get_all_jobs_status) | **GET** /jobs | 
*JobApi* | [**send_job_command**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/JobApi.md#send_job_command) | **PUT** /jobs/{id} | 
*LibraryApi* | [**create_library**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LibraryApi.md#create_library) | **POST** /library | 
*LibraryApi* | [**delete_library**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LibraryApi.md#delete_library) | **DELETE** /library/{id} | 
*LibraryApi* | [**get_libraries**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LibraryApi.md#get_libraries) | **GET** /library | 
*LibraryApi* | [**get_library_info**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LibraryApi.md#get_library_info) | **GET** /library/{id} | 
*LibraryApi* | [**get_library_statistics**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LibraryApi.md#get_library_statistics) | **GET** /library/{id}/statistics | 
*LibraryApi* | [**remove_offline_files**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LibraryApi.md#remove_offline_files) | **POST** /library/{id}/removeOffline | 
*LibraryApi* | [**scan_library**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LibraryApi.md#scan_library) | **POST** /library/{id}/scan | 
*LibraryApi* | [**update_library**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LibraryApi.md#update_library) | **PUT** /library/{id} | 
*OAuthApi* | [**finish_o_auth**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/OAuthApi.md#finish_o_auth) | **POST** /oauth/callback | 
*OAuthApi* | [**generate_o_auth_config**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/OAuthApi.md#generate_o_auth_config) | **POST** /oauth/config | 
*OAuthApi* | [**link_o_auth_account**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/OAuthApi.md#link_o_auth_account) | **POST** /oauth/link | 
*OAuthApi* | [**redirect_o_auth_to_mobile**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/OAuthApi.md#redirect_o_auth_to_mobile) | **GET** /oauth/mobile-redirect | 
*OAuthApi* | [**start_o_auth**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/OAuthApi.md#start_o_auth) | **POST** /oauth/authorize | 
*OAuthApi* | [**unlink_o_auth_account**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/OAuthApi.md#unlink_o_auth_account) | **POST** /oauth/unlink | 
*PartnerApi* | [**create_partner**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PartnerApi.md#create_partner) | **POST** /partner/{id} | 
*PartnerApi* | [**get_partners**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PartnerApi.md#get_partners) | **GET** /partner | 
*PartnerApi* | [**remove_partner**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PartnerApi.md#remove_partner) | **DELETE** /partner/{id} | 
*PartnerApi* | [**update_partner**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PartnerApi.md#update_partner) | **PUT** /partner/{id} | 
*PersonApi* | [**create_person**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonApi.md#create_person) | **POST** /person | 
*PersonApi* | [**get_all_people**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonApi.md#get_all_people) | **GET** /person | 
*PersonApi* | [**get_person**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonApi.md#get_person) | **GET** /person/{id} | 
*PersonApi* | [**get_person_assets**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonApi.md#get_person_assets) | **GET** /person/{id}/assets | 
*PersonApi* | [**get_person_statistics**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonApi.md#get_person_statistics) | **GET** /person/{id}/statistics | 
*PersonApi* | [**get_person_thumbnail**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonApi.md#get_person_thumbnail) | **GET** /person/{id}/thumbnail | 
*PersonApi* | [**merge_person**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonApi.md#merge_person) | **POST** /person/{id}/merge | 
*PersonApi* | [**reassign_faces**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonApi.md#reassign_faces) | **PUT** /person/{id}/reassign | 
*PersonApi* | [**update_people**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonApi.md#update_people) | **PUT** /person | 
*PersonApi* | [**update_person**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonApi.md#update_person) | **PUT** /person/{id} | 
*SearchApi* | [**get_explore_data**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SearchApi.md#get_explore_data) | **GET** /search/explore | 
*SearchApi* | [**search**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SearchApi.md#search) | **GET** /search | 
*SearchApi* | [**search_person**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SearchApi.md#search_person) | **GET** /search/person | 
*ServerInfoApi* | [**get_server_config**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerInfoApi.md#get_server_config) | **GET** /server-info/config | 
*ServerInfoApi* | [**get_server_features**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerInfoApi.md#get_server_features) | **GET** /server-info/features | 
*ServerInfoApi* | [**get_server_info**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerInfoApi.md#get_server_info) | **GET** /server-info | 
*ServerInfoApi* | [**get_server_statistics**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerInfoApi.md#get_server_statistics) | **GET** /server-info/statistics | 
*ServerInfoApi* | [**get_server_version**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerInfoApi.md#get_server_version) | **GET** /server-info/version | 
*ServerInfoApi* | [**get_supported_media_types**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerInfoApi.md#get_supported_media_types) | **GET** /server-info/media-types | 
*ServerInfoApi* | [**get_theme**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerInfoApi.md#get_theme) | **GET** /server-info/theme | 
*ServerInfoApi* | [**ping_server**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerInfoApi.md#ping_server) | **GET** /server-info/ping | 
*ServerInfoApi* | [**set_admin_onboarding**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerInfoApi.md#set_admin_onboarding) | **POST** /server-info/admin-onboarding | 
*SharedLinkApi* | [**add_shared_link_assets**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SharedLinkApi.md#add_shared_link_assets) | **PUT** /shared-link/{id}/assets | 
*SharedLinkApi* | [**create_shared_link**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SharedLinkApi.md#create_shared_link) | **POST** /shared-link | 
*SharedLinkApi* | [**get_all_shared_links**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SharedLinkApi.md#get_all_shared_links) | **GET** /shared-link | 
*SharedLinkApi* | [**get_my_shared_link**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SharedLinkApi.md#get_my_shared_link) | **GET** /shared-link/me | 
*SharedLinkApi* | [**get_shared_link_by_id**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SharedLinkApi.md#get_shared_link_by_id) | **GET** /shared-link/{id} | 
*SharedLinkApi* | [**remove_shared_link**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SharedLinkApi.md#remove_shared_link) | **DELETE** /shared-link/{id} | 
*SharedLinkApi* | [**remove_shared_link_assets**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SharedLinkApi.md#remove_shared_link_assets) | **DELETE** /shared-link/{id}/assets | 
*SharedLinkApi* | [**update_shared_link**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SharedLinkApi.md#update_shared_link) | **PATCH** /shared-link/{id} | 
*SystemConfigApi* | [**get_config**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigApi.md#get_config) | **GET** /system-config | 
*SystemConfigApi* | [**get_config_defaults**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigApi.md#get_config_defaults) | **GET** /system-config/defaults | 
*SystemConfigApi* | [**get_map_style**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigApi.md#get_map_style) | **GET** /system-config/map/style.json | 
*SystemConfigApi* | [**get_storage_template_options**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigApi.md#get_storage_template_options) | **GET** /system-config/storage-template-options | 
*SystemConfigApi* | [**update_config**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigApi.md#update_config) | **PUT** /system-config | 
*TagApi* | [**create_tag**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TagApi.md#create_tag) | **POST** /tag | 
*TagApi* | [**delete_tag**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TagApi.md#delete_tag) | **DELETE** /tag/{id} | 
*TagApi* | [**get_all_tags**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TagApi.md#get_all_tags) | **GET** /tag | 
*TagApi* | [**get_tag_assets**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TagApi.md#get_tag_assets) | **GET** /tag/{id}/assets | 
*TagApi* | [**get_tag_by_id**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TagApi.md#get_tag_by_id) | **GET** /tag/{id} | 
*TagApi* | [**tag_assets**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TagApi.md#tag_assets) | **PUT** /tag/{id}/assets | 
*TagApi* | [**untag_assets**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TagApi.md#untag_assets) | **DELETE** /tag/{id}/assets | 
*TagApi* | [**update_tag**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TagApi.md#update_tag) | **PATCH** /tag/{id} | 
*UserApi* | [**create_profile_image**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UserApi.md#create_profile_image) | **POST** /user/profile-image | 
*UserApi* | [**create_user**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UserApi.md#create_user) | **POST** /user | 
*UserApi* | [**delete_profile_image**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UserApi.md#delete_profile_image) | **DELETE** /user/profile-image | 
*UserApi* | [**delete_user**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UserApi.md#delete_user) | **DELETE** /user/{id} | 
*UserApi* | [**get_all_users**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UserApi.md#get_all_users) | **GET** /user | 
*UserApi* | [**get_my_user_info**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UserApi.md#get_my_user_info) | **GET** /user/me | 
*UserApi* | [**get_profile_image**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UserApi.md#get_profile_image) | **GET** /user/profile-image/{id} | 
*UserApi* | [**get_user_by_id**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UserApi.md#get_user_by_id) | **GET** /user/info/{id} | 
*UserApi* | [**restore_user**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UserApi.md#restore_user) | **POST** /user/{id}/restore | 
*UserApi* | [**update_user**](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UserApi.md#update_user) | **PUT** /user | 


## Documentation For Models

 - [APIKeyCreateDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/APIKeyCreateDto.md)
 - [APIKeyCreateResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/APIKeyCreateResponseDto.md)
 - [APIKeyResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/APIKeyResponseDto.md)
 - [APIKeyUpdateDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/APIKeyUpdateDto.md)
 - [ActivityCreateDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ActivityCreateDto.md)
 - [ActivityResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ActivityResponseDto.md)
 - [ActivityStatisticsResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ActivityStatisticsResponseDto.md)
 - [AddUsersDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AddUsersDto.md)
 - [AlbumCountResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AlbumCountResponseDto.md)
 - [AlbumResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AlbumResponseDto.md)
 - [AllJobStatusResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AllJobStatusResponseDto.md)
 - [AssetBulkDeleteDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetBulkDeleteDto.md)
 - [AssetBulkUpdateDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetBulkUpdateDto.md)
 - [AssetBulkUploadCheckDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetBulkUploadCheckDto.md)
 - [AssetBulkUploadCheckItem](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetBulkUploadCheckItem.md)
 - [AssetBulkUploadCheckResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetBulkUploadCheckResponseDto.md)
 - [AssetBulkUploadCheckResult](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetBulkUploadCheckResult.md)
 - [AssetFaceResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetFaceResponseDto.md)
 - [AssetFaceUpdateDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetFaceUpdateDto.md)
 - [AssetFaceUpdateItem](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetFaceUpdateItem.md)
 - [AssetFaceWithoutPersonResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetFaceWithoutPersonResponseDto.md)
 - [AssetFileUploadResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetFileUploadResponseDto.md)
 - [AssetIdsDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetIdsDto.md)
 - [AssetIdsResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetIdsResponseDto.md)
 - [AssetJobName](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetJobName.md)
 - [AssetJobsDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetJobsDto.md)
 - [AssetOrder](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetOrder.md)
 - [AssetResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetResponseDto.md)
 - [AssetStatsResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetStatsResponseDto.md)
 - [AssetTypeEnum](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AssetTypeEnum.md)
 - [AudioCodec](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AudioCodec.md)
 - [AuditDeletesResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuditDeletesResponseDto.md)
 - [AuthDeviceResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/AuthDeviceResponseDto.md)
 - [BulkIdResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/BulkIdResponseDto.md)
 - [BulkIdsDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/BulkIdsDto.md)
 - [CLIPConfig](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/CLIPConfig.md)
 - [CLIPMode](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/CLIPMode.md)
 - [CQMode](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/CQMode.md)
 - [ChangePasswordDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ChangePasswordDto.md)
 - [CheckExistingAssetsDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/CheckExistingAssetsDto.md)
 - [CheckExistingAssetsResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/CheckExistingAssetsResponseDto.md)
 - [Colorspace](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/Colorspace.md)
 - [CreateAlbumDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/CreateAlbumDto.md)
 - [CreateLibraryDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/CreateLibraryDto.md)
 - [CreateProfileImageResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/CreateProfileImageResponseDto.md)
 - [CreateTagDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/CreateTagDto.md)
 - [CreateUserDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/CreateUserDto.md)
 - [CuratedLocationsResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/CuratedLocationsResponseDto.md)
 - [CuratedObjectsResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/CuratedObjectsResponseDto.md)
 - [DownloadArchiveInfo](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/DownloadArchiveInfo.md)
 - [DownloadInfoDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/DownloadInfoDto.md)
 - [DownloadResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/DownloadResponseDto.md)
 - [EntityType](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/EntityType.md)
 - [ExifResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ExifResponseDto.md)
 - [FaceDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/FaceDto.md)
 - [FileChecksumDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/FileChecksumDto.md)
 - [FileChecksumResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/FileChecksumResponseDto.md)
 - [FileReportDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/FileReportDto.md)
 - [FileReportFixDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/FileReportFixDto.md)
 - [FileReportItemDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/FileReportItemDto.md)
 - [JobCommand](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/JobCommand.md)
 - [JobCommandDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/JobCommandDto.md)
 - [JobCountsDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/JobCountsDto.md)
 - [JobName](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/JobName.md)
 - [JobSettingsDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/JobSettingsDto.md)
 - [JobStatusDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/JobStatusDto.md)
 - [LibraryResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LibraryResponseDto.md)
 - [LibraryStatsResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LibraryStatsResponseDto.md)
 - [LibraryType](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LibraryType.md)
 - [LogLevel](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LogLevel.md)
 - [LoginCredentialDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LoginCredentialDto.md)
 - [LoginResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LoginResponseDto.md)
 - [LogoutResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/LogoutResponseDto.md)
 - [MapMarkerResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/MapMarkerResponseDto.md)
 - [MapTheme](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/MapTheme.md)
 - [MemoryLaneResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/MemoryLaneResponseDto.md)
 - [MergePersonDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/MergePersonDto.md)
 - [ModelType](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ModelType.md)
 - [OAuthAuthorizeResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/OAuthAuthorizeResponseDto.md)
 - [OAuthCallbackDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/OAuthCallbackDto.md)
 - [OAuthConfigDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/OAuthConfigDto.md)
 - [OAuthConfigResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/OAuthConfigResponseDto.md)
 - [PartnerResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PartnerResponseDto.md)
 - [PathEntityType](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PathEntityType.md)
 - [PathType](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PathType.md)
 - [PeopleResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PeopleResponseDto.md)
 - [PeopleUpdateDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PeopleUpdateDto.md)
 - [PeopleUpdateItem](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PeopleUpdateItem.md)
 - [PersonResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonResponseDto.md)
 - [PersonStatisticsResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonStatisticsResponseDto.md)
 - [PersonUpdateDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonUpdateDto.md)
 - [PersonWithFacesResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/PersonWithFacesResponseDto.md)
 - [QueueStatusDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/QueueStatusDto.md)
 - [ReactionLevel](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ReactionLevel.md)
 - [ReactionType](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ReactionType.md)
 - [RecognitionConfig](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/RecognitionConfig.md)
 - [ScanLibraryDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ScanLibraryDto.md)
 - [SearchAlbumResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SearchAlbumResponseDto.md)
 - [SearchAssetResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SearchAssetResponseDto.md)
 - [SearchExploreItem](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SearchExploreItem.md)
 - [SearchExploreResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SearchExploreResponseDto.md)
 - [SearchFacetCountResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SearchFacetCountResponseDto.md)
 - [SearchFacetResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SearchFacetResponseDto.md)
 - [SearchResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SearchResponseDto.md)
 - [ServerConfigDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerConfigDto.md)
 - [ServerFeaturesDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerFeaturesDto.md)
 - [ServerInfoResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerInfoResponseDto.md)
 - [ServerMediaTypesResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerMediaTypesResponseDto.md)
 - [ServerPingResponse](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerPingResponse.md)
 - [ServerStatsResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerStatsResponseDto.md)
 - [ServerThemeDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerThemeDto.md)
 - [ServerVersionResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ServerVersionResponseDto.md)
 - [SharedLinkCreateDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SharedLinkCreateDto.md)
 - [SharedLinkEditDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SharedLinkEditDto.md)
 - [SharedLinkResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SharedLinkResponseDto.md)
 - [SharedLinkType](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SharedLinkType.md)
 - [SignUpDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SignUpDto.md)
 - [SmartInfoResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SmartInfoResponseDto.md)
 - [SystemConfigDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigDto.md)
 - [SystemConfigFFmpegDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigFFmpegDto.md)
 - [SystemConfigJobDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigJobDto.md)
 - [SystemConfigLibraryDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigLibraryDto.md)
 - [SystemConfigLibraryScanDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigLibraryScanDto.md)
 - [SystemConfigLoggingDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigLoggingDto.md)
 - [SystemConfigMachineLearningDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigMachineLearningDto.md)
 - [SystemConfigMapDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigMapDto.md)
 - [SystemConfigNewVersionCheckDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigNewVersionCheckDto.md)
 - [SystemConfigOAuthDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigOAuthDto.md)
 - [SystemConfigPasswordLoginDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigPasswordLoginDto.md)
 - [SystemConfigReverseGeocodingDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigReverseGeocodingDto.md)
 - [SystemConfigServerDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigServerDto.md)
 - [SystemConfigStorageTemplateDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigStorageTemplateDto.md)
 - [SystemConfigTemplateStorageOptionDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigTemplateStorageOptionDto.md)
 - [SystemConfigThemeDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigThemeDto.md)
 - [SystemConfigThumbnailDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigThumbnailDto.md)
 - [SystemConfigTrashDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/SystemConfigTrashDto.md)
 - [TagResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TagResponseDto.md)
 - [TagTypeEnum](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TagTypeEnum.md)
 - [ThumbnailFormat](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ThumbnailFormat.md)
 - [TimeBucketResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TimeBucketResponseDto.md)
 - [TimeBucketSize](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TimeBucketSize.md)
 - [ToneMapping](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ToneMapping.md)
 - [TranscodeHWAccel](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TranscodeHWAccel.md)
 - [TranscodePolicy](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/TranscodePolicy.md)
 - [UpdateAlbumDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UpdateAlbumDto.md)
 - [UpdateAssetDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UpdateAssetDto.md)
 - [UpdateLibraryDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UpdateLibraryDto.md)
 - [UpdatePartnerDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UpdatePartnerDto.md)
 - [UpdateStackParentDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UpdateStackParentDto.md)
 - [UpdateTagDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UpdateTagDto.md)
 - [UpdateUserDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UpdateUserDto.md)
 - [UsageByUserDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UsageByUserDto.md)
 - [UserAvatarColor](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UserAvatarColor.md)
 - [UserDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UserDto.md)
 - [UserResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/UserResponseDto.md)
 - [ValidateAccessTokenResponseDto](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/ValidateAccessTokenResponseDto.md)
 - [VideoCodec](https://github.com/Marian-Braendle/immich-python-sdk/tree/immich-v1.93.0/docs/VideoCodec.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="bearer"></a>
### bearer

- **Type**: Bearer authentication (JWT)

<a id="cookie"></a>
### cookie

- **Type**: API key
- **API key parameter name**: immich_access_token
- **Location**: 

<a id="api_key"></a>
### api_key

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header


## Author




